FLAIM: Database Create, Open, Close

- Main Page
- Modules
- Classes
- Files

# Database Create, Open, Close
[Database Functions]

## Functions
FLMEXP RCODE FLMAPI | FlmDbCreate (const char *pszDbFileName, const char *pszDataDir, const char *pszRflDir, const char *pszDictFileName, const char *pszDictBuf, CREATE_OPTS *pCreateOpts, HFDB *phDb)
| Create a new database.
FLMEXP RCODE FLMAPI | FlmDbOpen (const char *pszDbFileName, const char *pszDataDir, const char *pszRflDir, FLMUINT uiOpenFlags, const char *pszPassword, HFDB *phDb)
| Open a database.
FLMEXP RCODE FLMAPI | FlmDbClose (HFDB *phDb)
| Close a database.

## Function Documentation

FLMEXP RCODE FLMAPI FlmDbClose | ( | HFDB * | phDb | ) |

  | Close a database. Parameters:
  phDb | Pointer to database handle that is to be closed. The database handle will be set back to HFDB_NULL.

FLMEXP RCODE FLMAPI FlmDbCreate | ( | const char * | pszDbFileName,
|  | const char * | pszDataDir,
|  | const char * | pszRflDir,
|  | const char * | pszDictFileName,
|  | const char * | pszDictBuf,
|  | CREATE_OPTS * | pCreateOpts,
|  | HFDB * | phDb
| ) |

  | Create a new database. Parameters:
  pszDbFileName | Name of database to be created. May be full path name or partial path name.
  pszDataDir | Name of directory where data files are to be created. If NULL, data files will be in the same directory as the main database file - pszDbFileName.
  pszRflDir | Name of the directory where RFL files are to be created. If NULL, RFL files will be in the same directory as the main database file - pszDbFileName.
  pszDictFileName | Name of a file containing dictionary definitions that are to be read in and put into the database's dictionary. This is only used if the pszDictBuf parameter is NULL. If both pszDictFileName and pszDictBuf parameters are NULL, the database's dictionary will not be populated.
  pszDictBuf | String buffer containing dictionary definitions that are to be put into the database's dictionary. If this parameter is NULL, then pszDictFileName is used. If both pszDictFileName and pszDictBuf parameters are NULL, the database's dictionary will not be populated.
  pCreateOpts | Create options for the database.
  phDb | If database is successfully created, a database handle is returned here. It is not necessary to call FlmDbOpen() to get a database handle.

FLMEXP RCODE FLMAPI FlmDbOpen | ( | const char * | pszDbFileName,
|  | const char * | pszDataDir,
|  | const char * | pszRflDir,
|  | FLMUINT | uiOpenFlags,
|  | const char * | pszPassword,
|  | HFDB * | phDb
| ) |

  | Open a database. Parameters:
  pszDbFileName | Name of database to be opened. May be full path name or partial path name.
  pszDataDir | Name of directory where data files for the database are located. If NULL, data files are assumed to be in the same directory as the main database file - pszDbFileName.
  pszRflDir | Name of the directory where RFL files are located. If NULL, RFL files are assumed to be in the same directory as the main database file - pszDbFileName.
  uiOpenFlags | Flags for opening the database. They are as follows: FO_ALLOW_LIMITED - Allow limited access to database even if the database key cannot be accessed for some reason. It may be that NICI is not available, but the application would still like to be able to access non-encrypted data FO_DONT_RESUME_BACKGROUND_THREADS - Tells FLAIM to NOT restart any indexing background threads. This should only be used when the application does not want modifications made to the database. This flag is only recognized on the first open of the database. If the database has already been opened elsewhere, this flag is ignored FO_DONT_REDO_LOG - Don't replay the RFL log to recover transactions. This should only be performed if the application does not want the database to be changed in any way, including replaying of roll-forward logs. NOTE: The checkpoint thread will not be started for this database if this flag is set. This flag is only recognized on the first open of the database. If the database has already been opened elsewhere, this flag is ignored
  pszPassword | Password for opening the database. This parameter is normally NULL. It should only be specified if the database's database key is currently wrapped in a password.
  phDb | If database is successfully opened, database handle is returned here.